<template>
  <rui-form model="resource_interactions_group"
            :loading="loading"
            :errors="errors"
            @cancel="$emit('cancel')"
            @submit.prevent="save">
    <rui-alert variant="info">{{ $t('js.resource_interactions_group.form.community_alert') }}</rui-alert>

    <rui-field input-id="resource_interaction_form_name" :label="$t('activerecord.attributes.resource_interactions_group.name')">
      <input id="resource_interaction_form_name"
             v-model="inputs.name"
             type="text"
             autocomplete="off"
             required>
    </rui-field>

    <rui-field input-id="resource_interaction_form_description" :label="$t('activerecord.attributes.resource_interactions_group.description')">
      <textarea id="resource_interaction_form_description"
                v-model="inputs.description"
                class="-large"
                autocomplete="off" />
    </rui-field>
  </rui-form>
</template>
<script>
import RuiAlert from '@experiments-labs/rise_ui/src/components/Alert/Alert.vue'
import RuiField from '@experiments-labs/rise_ui/src/components/Form/Field.vue'
import RuiForm from '@experiments-labs/rise_ui/src/components/Form/Form.vue'

import ResourceInteractionsGroup from '../../../../classes/models/ResourceInteractionsGroup'
import Toaster from '../../../../tools/Toaster'

export default {
  name: 'GpaResourceInteractionsGroupForm',
  emits: [
    'cancel',
    'saved',
  ],
  components: { RuiField, RuiAlert, RuiForm },
  props: {
    resourceInteractionsGroup: { required: false, type: ResourceInteractionsGroup, default: null },
  },
  data () {
    return {
      errors: null,
      loading: false,
      inputs: {
        id: null,
        name: null,
        description: null,
      },
    }
  },
  methods: {
    setInputs () {
      if (!this.$props.resourceInteractionsGroup) {
        this.inputs = { id: null, name: null, description: null }
        return
      }

      this.inputs = {
        id: this.$props.resourceInteractionsGroup.id,
        name: this.$props.resourceInteractionsGroup.name,
        description: this.$props.resourceInteractionsGroup.description,
      }
    },
    save () {
      const payload = { ...this.inputs }
      this.errors = null
      this.loading = true
      this.$store.dispatch('saveResourceInteractionsGroup', payload)
        .then(() => {
          Toaster.success(this.$t('js.generic.successfully_saved'))
          this.$emit('saved')
        })
        .catch((errors) => {
          Toaster.error(this.$t('js.generic.failed_to_save'))
          this.errors = errors
        })
        .then(() => { this.loading = false })
    },
  },
  mounted () {
    this.setInputs()
  },
  watch: {
    resourceInteractionsGroup () {
      this.setInputs()
    },
  },
}
</script>
